#include <jni.h>
#include <stdio.h>
#include "TestJNIInstanceVariable.h"

JNIEXPORT void JNICALL Java_TestJNIInstanceVariable_modifyInstanceVariable
          (JNIEnv *env, jobject thisObj) {
   // Pobierz referencję do klasy obiektu thisObj
   jclass thisClass = (*env)->GetObjectClass(env, thisObj);

   // int
   // Pobierz identyfikator atrybutu "number" w klasie thisClass
   jfieldID fidNumber = (*env)->GetFieldID(env, thisClass, "number", "I");
   if (NULL == fidNumber) return;

   // Pobierz wartość atrybutu "number" w obiekcie thisObj
   jint number = (*env)->GetIntField(env, thisObj, fidNumber);
   printf("In C, the int is %d\n", number);

   // Zmień wartość atrybutu "number"
   number = 99;
   (*env)->SetIntField(env, thisObj, fidNumber, number);

   // Pobierz identyfikator atrybutu "message" w klasie thisClass
   jfieldID fidMessage = (*env)->GetFieldID(env, thisClass, "message", "Ljava/lang/String;");
   if (NULL == fidMessage) return;

   // String
   // Pobierz wartość atrybutu "message" w obiekcie thisObj
   jstring message = (*env)->GetObjectField(env, thisObj, fidMessage);

   // Utwórz łańcuch znaków języka C ze zmiennej  JNI typu String
   const char *cStr = (*env)->GetStringUTFChars(env, message, NULL);
   if (NULL == cStr) return;

   printf("In C, the string is %s\n", cStr);
   (*env)->ReleaseStringUTFChars(env, message, cStr);

   // Przypisz do zmiennej JNI typu String nową wartość określoną przez łańcuch znaków C
   message = (*env)->NewStringUTF(env, "Hello from C");
   if (NULL == message) return;

   // Zmień wartość atrybutu "message"
   (*env)->SetObjectField(env, thisObj, fidMessage, message);
}
