#include <jni.h>
#include <stdio.h>
#include "TestJNIObjectArray.h"

JNIEXPORT jobjectArray JNICALL Java_TestJNIObjectArray_sumAndAverage
          (JNIEnv *env, jobject thisObj, jobjectArray inJNIArray) {
   // Pobierz referencję do klasy java.lang.Integer
   jclass classInteger = (*env)->FindClass(env, "java/lang/Integer");
   // Pobierz identyfikator metody Integer.intValue() zwracającej wartość int obiektu klasy Integer
   jmethodID midIntValue = (*env)->GetMethodID(env, classInteger, "intValue", "()I");
   if (NULL == midIntValue) return NULL;

   //Pobierz ilość elementów tablicy przekazanej w parametrze
   jsize length = (*env)->GetArrayLength(env, inJNIArray);
   jint sum = 0;
   int i;
   for (i = 0; i < length; i++) {
       // Pobierz i-ty obiekt z tablicy
       jobject objInteger = (*env)->GetObjectArrayElement(env, inJNIArray, i);
       if (NULL == objInteger) return NULL;
       // Wywołaj metodę intValue na pobranym obiekcie
       jint value = (*env)->CallIntMethod(env, objInteger, midIntValue);
       // zaktualizuj sumę
       sum += value;
   }
   // oblicz średnią
   double average = (double)sum / length;
   printf("In C, the sum is %d\n", sum);
   printf("In C, the average is %f\n", average);

   //Pobierz referencję na klasę java.lang.Double
   jclass classDouble = (*env)->FindClass(env, "java/lang/Double");

   // Utwórz tablicę 2 elementów klasy java.lang.Double
   jobjectArray outJNIArray = (*env)->NewObjectArray(env, 2, classDouble, NULL);

   // Pobierz identyfikator konstruktora klasy Double
   jmethodID midDoubleInit = (*env)->GetMethodID(env, classDouble, "<init>", "(D)V");
   if (NULL == midDoubleInit) return NULL;
   // Utwórz dwa obiekty klasy Double przechowujące sumę i średnią odpowiednio
   jobject objSum = (*env)->NewObject(env, classDouble, midDoubleInit, (double)sum);
   jobject objAve = (*env)->NewObject(env, classDouble, midDoubleInit, average);
   // Ustaw elementy tablicy
   (*env)->SetObjectArrayElement(env, outJNIArray, 0, objSum);
   (*env)->SetObjectArrayElement(env, outJNIArray, 1, objAve);

   // i zwróć tablicę do programu Javy
   return outJNIArray;
}
