#include <jni.h>
#include <stdio.h>
#include "TestJNIReference.h"

// Global Reference to the Java class "java.lang.Integer"
static jclass classInteger;
static jmethodID midIntegerInit;

jobject getInteger(JNIEnv *env, jobject thisObj, jint number) {

   // Get a class reference for java.lang.Integer if missing
   if (NULL == classInteger) {
       printf("Uzyskanie reerencji na klasę java.lang.Integer\n");
       // FindClass returns a local reference
       jclass classIntegerLocal = (*env)->FindClass(env, "java/lang/Integer");
       // Create a global reference from the local reference
       classInteger = (*env)->NewGlobalRef(env, classIntegerLocal);
       // No longer need the local reference, free it!
       (*env)->DeleteLocalRef(env, classIntegerLocal);
   }
   if (NULL == classInteger) return NULL;

   // Get the Method ID of the Integer's constructor if missing
   if (NULL == midIntegerInit) {
      printf("Pobierz identyfikator konstruktora klasy java.lang.Integer's\n");
      midIntegerInit = (*env)->GetMethodID(env, classInteger, "<init>", "(I)V");
   }
   if (NULL == midIntegerInit) return NULL;

   // Call back constructor to allocate a new instance, with an int argument
   jobject newObj = (*env)->NewObject(env, classInteger, midIntegerInit, number);
   printf("W C, utworzono obiekt klasy java.lang.Integer zawierający wartość %d\n", number);
   return newObj;
}

JNIEXPORT jobject JNICALL Java_TestJNIReference_getIntegerObject
          (JNIEnv *env, jobject thisObj, jint number) {
   return getInteger(env, thisObj, number);
}

JNIEXPORT jobject JNICALL Java_TestJNIReference_anotherGetIntegerObject
          (JNIEnv *env, jobject thisObj, jint number) {
   return getInteger(env, thisObj, number);
}
